#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug  6 08:46:29 2018
test_geom is the "to be completed" script for practical 4
part 1 of computer vision lectures 
@author: thierrychateau
"""
import cv2
from matplotlib import pyplot as plt
import numpy as np
#import pdb ; pdb.set_trace()

# Here are some functions used to compute transformation matrices
def roty(t):
    Ry=np.array([(np.cos(t) ,0 ,np.sin(t) ,0),\
                 (0 ,1 ,0 ,0),\
                 (-np.sin(t) ,0 ,np.cos(t) ,0),\
                 (0 ,0 ,0 ,1)])
    return Ry
def rotx(t):
    Rx=np.array([(1 ,0 ,0 ,0),\
                 (0, np.cos(t)  ,-np.sin(t)  ,0),\
                 (0, np.sin(t), np.cos(t), 0),\
                 (0, 0, 0, 1)])
    return Rx
def rotz(t):
    Rz=np.array([(np.cos(t), -np.sin(t), 0, 0),\
                 (np.sin(t),  np.cos(t), 0, 0),\
                 (0, 0, 1, 0),\
                 (0, 0, 0, 1)])
    return Rz
def trans(x,y,z):
    T=np.array([(1, 0, 0, x),\
                (0, 1, 0, y),\
                (0, 0, 1, z),\
                (0, 0, 0, 1)])
    return T
# Convert Deg./Rad.
def DR(d):
    return (d*np.pi/180)
# Here is the function that projects a 3D Point P into the camera C
# Proj one point P in cam C (P in cartesian coordinates)
def proj(C,P):
    P = np.append(P,1)
    p = C @ P
    pc = np.array([p[0]/p[2],p[1]/p[2]])
    return (pc)
#
# This is the main function that is launched when this file is run as a script
#
def main():
    # Read cam1 (left) and cam2(right) images file 
    il = cv2.imread("cam1.png",0) # ,0 to load as grayscale image
    ir = cv2.imread("cam2.png",0)
    # Intrinsec parameters (no distorsion)
    u0 = 800
    v0 = 600
    f = 1750 # focal in pixels (fx = fy)
    # Compute intrisec matrix
    # TO BE COMPLETED
    Mi = np.array([(...),\
                   (...),\
                   (...)])
    # Compute extrinsec matrices
    # TO BE COMPLETED
    Mel = ...
    Mer = ...
    # Compute camera model
    # Tips : matrix product symbol for python is @
    Cl = ...
    Cr = ...
    print("Cl = ",Cl)
    print("Cr = ",Cr)
    # proj. one cube corner into images
    # TO BE COMPLETED
    P1 = np.array([...]) # cartesian coordinates
    pl = proj(Cl,P1)
    pr = proj(Cr,P1)
    # Display
    plt.subplot(121)
    plt.imshow(il,'gray')
    plt.title('left image')
    plt.plot(pl[0],pl[1],'og')
    plt.subplot(122)
    plt.imshow(ir,'gray')
    plt.title('right image')
    plt.plot(pr[0],pr[1],'og')
    plt.show()
    
if __name__ == "__main__":
    # execute only if run as a script
    main()
