#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug  6 08:46:29 2018
test_geom is the "to be completed" script for practical 4
part 1 of computer vision lectures 
@author: thierrychateau
"""
import cv2
from matplotlib import pyplot as plt
import numpy as np
#import pdb ; pdb.set_trace()

# Here are some functions used to compute transformation matrices
def roty(t):
    Ry=np.array([(np.cos(t) ,0 ,np.sin(t) ,0),\
                 (0 ,1 ,0 ,0),\
                 (-np.sin(t) ,0 ,np.cos(t) ,0),\
                 (0 ,0 ,0 ,1)])
    return Ry
def rotx(t):
    Rx=np.array([(1 ,0 ,0 ,0),\
                 (0, np.cos(t)  ,-np.sin(t)  ,0),\
                 (0, np.sin(t), np.cos(t), 0),\
                 (0, 0, 0, 1)])
    return Rx
def rotz(t):
    Rz=np.array([(np.cos(t), -np.sin(t), 0, 0),\
                 (np.sin(t),  np.cos(t), 0, 0),\
                 (0, 0, 1, 0),\
                 (0, 0, 0, 1)])
    return Rz
def trans(x,y,z):
    T=np.array([(1, 0, 0, x),\
                (0, 1, 0, y),\
                (0, 0, 1, z),\
                (0, 0, 0, 1)])
    return T
# Convert Deg./Rad.
def DR(d):
    return (d*np.pi/180)
# Here is the function that projects a 3D Point P into the camera C
# Proj one point P in cam C (P in cartesian coordinates)
def proj(C,P):
    P = np.append(P,1)
    p = C @ P
    pc = np.array([p[0]/p[2],p[1]/p[2]])
    return (pc)
#
# Compute 3D coordinates from point proj into two cams.
#
def triangulate(C1,C2,p1,p2):
    # Build linear system
    # TO BE COMPLETED
    Line 1 of matrix A
    A1 = np.array([...])
    Line 2 of matrix A
    A2 = np.array([])
    A3 = np.array([])
    A4 = np.array([])
    A = np.array([A1,A2,A3,A4])
    Line 1 of matrix B
    # TO BE COMPLETED
    B1 = np.array([])
    B2 = np.array([])
    B3 = np.array([])
    B4 = np.array([])
    B = np.array([B1,B2,B3,B4])
    print("A = ",A)
    # TO BE COMPLETED 
    # TIPS: use np.linalg.pinv(x) to compute the pseudo-invert of the matrix x
    P = ...
    return P
# Display a text into the figure
def tellme(s):
    print(s)
    plt.title(s)#, fontsize=16)
    plt.draw()
#
# This is the main function that is launched when this file is run as a script
#
def main():
    # Read cam1 (left) and cam2(right) images file 
    il = cv2.imread("cam1.png",0) # ,0 to load as grayscale image
    ir = cv2.imread("cam2.png",0)
    # Intrinsec parameters (no distorsion)
    u0 = 800
    v0 = 600
    f = 1750 # focal in pixels (fx = fy)
    # Compute intrisec matrix
    Mi = np.array([(f,0,u0,0),\
                   (0,f,v0,0),\
                   (0,0,1,0)])
    # Compute extrinsec matrices
    Mel = roty(DR(-20)) @ rotx(DR(180)) @ trans(2,0,0)
    Mer = roty(DR(20)) @ rotx(DR(180)) @ trans(-2,0,0)
    # Compute camera model
    Cl = Mi @ Mel
    Cr = Mi @ Mer
    print("Cl = ",Cl)
    print("Cr = ",Cr)
    # Display
    plt.subplot(121)
    plt.imshow(il,'gray')
    plt.title('left image')
    plt.subplot(122)
    plt.imshow(ir,'gray')
    plt.title('right image')
     # click one point in each camera
    plt.subplot(121)
    tellme('Select 1 point on left image with mouse')
    pl=plt.ginput()
    tellme('Left image')
    #pdb.set_trace()
    pl = np.asarray(pl[0])
    plt.subplot(122)
    tellme('Select 1 point with right image with mouse')
    pr=plt.ginput()
    tellme('Right image')
    pr = np.asarray(pr[0])
    print(pr)
    # triangulate
    X = triangulate(Cl,Cr,pl,pr)
    print("P3d = ",X)
    plt.show()
    
if __name__ == "__main__":
    # execute only if run as a script
    main()
