#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug  6 08:46:29 2018
test_geom is the "to be completed" script for practical 4
part 2 of computer vision lectures 
@author: thierrychateau
"""
import cv2
import my_func as mf
from matplotlib import pyplot as plt
import numpy as np
import math
#import pdb ; pdb.set_trace()

def roty(t):
    Ry=np.array([(np.cos(t) ,0 ,np.sin(t) ,0),\
                 (0 ,1 ,0 ,0),\
                 (-np.sin(t) ,0 ,np.cos(t) ,0),\
                 (0 ,0 ,0 ,1)])
    return Ry

def rotx(t):
    Rx=np.array([(1 ,0 ,0 ,0),\
                 (0, np.cos(t)  ,-np.sin(t)  ,0),\
                 (0, np.sin(t), np.cos(t), 0),\
                 (0, 0, 0, 1)])
    return Rx

def rotz(t):
    Rz=np.array([(np.cos(t), -np.sin(t), 0, 0),\
                 (np.sin(t),  np.cos(t), 0, 0),\
                 (0, 0, 1, 0),\
                 (0, 0, 0, 1)])
    return Rz

def trans(x,y,z):
    T=np.array([(1, 0, 0, x),\
                (0, 1, 0, y),\
                (0, 0, 1, z),\
                (0, 0, 0, 1)])
    return T

# Convert Deg./Rad.
def DR(d):
    return (d*np.pi/180)
# Proj one point P in cam C (P in cartesian coordinates)
def proj(C,P):
    P = np.append(P,1)
    p = C @ P
    pc = np.array([p[0]/p[2],p[1]/p[2]])
    return (pc)
# build intrinsec 3x4 matrix

# This is the main function that is launched when this file is run as a script
def main():
    # Read cam2 (left) and cam3(right) images file 
    il = cv2.imread("Kitti/Cam2/000012_10.png") # ,0 to load as grayscale image
    ir = cv2.imread("Kitti/Cam3/000012_10.png")
    il = cv2.cvtColor(il, cv2.COLOR_BGR2RGB)
    ir = cv2.cvtColor(ir, cv2.COLOR_BGR2RGB)
    # camera model
    Cl = np.array([[7.215377e+02, 0.000000e+00, 6.095593e+02, 4.485728e+01],\
                   [0.000000e+00, 7.215377e+02, 1.728540e+02, 2.163791e-01],\
                   [0.000000e+00, 0.000000e+00, 1.000000e+00, 2.745884e-03]])
    Cr = np.array([[7.215377e+02, 0.000000e+00, 6.095593e+02, -3.395242e+02],\
                   [0.000000e+00, 7.215377e+02, 1.728540e+02, 2.199936e+00],\
                   [0.000000e+00, 0.000000e+00, 1.000000e+00, 2.729905e-03]])
  
    fig = plt.figure()
    ax1 = fig.add_subplot(111)
    ax1.imshow(il,'gray')
    ax1.set_title('left image')
    f = mf.zoom_factory(ax1)
    print("click two points on left image")
    pl= plt.ginput(2)
    pl = np.asarray(pl)
    print("OK")
    plt.close(fig)
    fig = plt.figure()
    ax1 = fig.add_subplot(111)
    ax1.imshow(ir,'gray')
    ax1.set_title('right image')
    print("Now: click the same points in the same order in the right image")
    f = mf.zoom_factory(ax1)
    pr= plt.ginput(2)
    pr = np.asarray(pr)
    # triangulate with opencv
    # TO BE FILL BY STUDENT using cv2.triangulatePoints function
    # TIPS : np.transpose(.) may be used if necessary
    Xcv = ...
    Xcv /= Xcv[3]
    print("P3d cv = ",Xcv[0:-1,:])
    # Compupte distance between the two 3D points
    # TO BE FILL BY STUDENT 
    dist = ...
    print("distance = ",dist) 
    # proj. into images
    P1 = Xcv[0:-1,0]
    P2 = Xcv[0:-1,1]
    pl1 = proj(Cl,P1)
    pr1 = proj(Cr,P1)
    pl2 = proj(Cl,P2)
    pr2 = proj(Cr,P2)
    plt.close(fig)
    fig = plt.figure()
    plt.subplot(211)
    plt.imshow(il)
    plt.title('left image')
    plt.plot([pl1[0], pl2[0]],[pl1[1],pl2[1]],'og-',linewidth=4)
    plt.text((pl1[0] + pl2[0])/2.0,(pl1[1] + pl1[1])/2.0-50,"%2.2f m" % dist, \
                 bbox=dict(facecolor='green', alpha=0.5),\
                 horizontalalignment='center')
    plt.subplot(212)
    plt.imshow(ir)
    plt.title('right image')
    plt.plot([pr1[0], pr2[0]],[pr1[1],pr2[1]],'og-',linewidth=4)
    plt.text((pr1[0] + pr2[0])/2.0,(pr1[1] + pr2[1])/2.0-50,"%2.2f m" % dist, \
                 bbox=dict(facecolor='green', alpha=0.5),\
                 horizontalalignment='center')
    plt.show()
    
if __name__ == "__main__":
    # execute only if run as a script
    main()
